
/*
* This is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <stdio.h>
#include <stdlib.h>

#include "crypto.h"
#include <limits.h>

#include <stdint.h>
int64_t main_key_bitwise_one = 999888777666555 ;

struct crypt_keys_caesar g_ptr_main_struct_caesar_one;
struct crypt_keys_bitwise g_ptr_main_struct_bitwise_one;
struct crypt_keys_caesar g_ptr_main_struct_caesar_two;
struct crypt_keys_bitwise g_ptr_main_struct_bitwise_two;
struct crypt_keys_caesar g_ptr_main_struct_caesar_three;
struct crypt_keys_bitwise g_ptr_main_struct_bitwise_three;
struct crypt_keys_caesar g_ptr_main_struct_caesar_four;
struct crypt_keys_bitwise g_ptr_main_struct_bitwise_four;

void set_crypt_keys_one(){
    g_ptr_main_struct_caesar_one.crypt_key_caesar_one = 111222333444555;
    g_ptr_main_struct_caesar_one.crypt_key_caesar_two = 111333444555666;
    g_ptr_main_struct_caesar_one.crypt_key_caesar_three = 111444555666777;
    g_ptr_main_struct_caesar_one.crypt_key_caesar_four = 111555666777888;

    g_ptr_main_struct_bitwise_one.crypt_key_bitwise_one = 222333444555666;
    g_ptr_main_struct_bitwise_one.crypt_key_bitwise_two = 222444555666777;
    g_ptr_main_struct_bitwise_one.crypt_key_bitwise_three = 222555666777888;
    g_ptr_main_struct_bitwise_one.crypt_key_bitwise_four = 222666777888999;
}
void set_crypt_keys_two(){
    g_ptr_main_struct_caesar_two.crypt_key_caesar_one = 111222333444555;
    g_ptr_main_struct_caesar_two.crypt_key_caesar_two = 111333444555666;
    g_ptr_main_struct_caesar_two.crypt_key_caesar_three = 111444555666777;
    g_ptr_main_struct_caesar_two.crypt_key_caesar_four = 111555666777888;

    g_ptr_main_struct_bitwise_two.crypt_key_bitwise_one = 222333444555666;
    g_ptr_main_struct_bitwise_two.crypt_key_bitwise_two = 222444555666777;
    g_ptr_main_struct_bitwise_two.crypt_key_bitwise_three = 222555666777888;
    g_ptr_main_struct_bitwise_two.crypt_key_bitwise_four = 222666777888999;
}
void set_crypt_keys_three(){
    g_ptr_main_struct_caesar_three.crypt_key_caesar_one = 111222333444555;
    g_ptr_main_struct_caesar_three.crypt_key_caesar_two = 111333444555666;
    g_ptr_main_struct_caesar_three.crypt_key_caesar_three = 111444555666777;
    g_ptr_main_struct_caesar_three.crypt_key_caesar_four = 111555666777888;

    g_ptr_main_struct_bitwise_three.crypt_key_bitwise_one = 222333444555666;
    g_ptr_main_struct_bitwise_three.crypt_key_bitwise_two = 222444555666777;
    g_ptr_main_struct_bitwise_three.crypt_key_bitwise_three = 222555666777888;
    g_ptr_main_struct_bitwise_three.crypt_key_bitwise_four = 222666777888999;
}
void set_crypt_keys_four(){
    g_ptr_main_struct_caesar_four.crypt_key_caesar_one = 111222333444555;
    g_ptr_main_struct_caesar_four.crypt_key_caesar_two = 111333444555666;
    g_ptr_main_struct_caesar_four.crypt_key_caesar_three = 111444555666777;
    g_ptr_main_struct_caesar_four.crypt_key_caesar_four = 111555666777888;

    g_ptr_main_struct_bitwise_four.crypt_key_bitwise_one = 222333444555666;
    g_ptr_main_struct_bitwise_four.crypt_key_bitwise_two = 222444555666777;
    g_ptr_main_struct_bitwise_four.crypt_key_bitwise_three = 222555666777888;
    g_ptr_main_struct_bitwise_four.crypt_key_bitwise_four = 222666777888999;
}





int main(int argc,char **argv){
	if ( argv[1] == NULL && argv[2] == NULL) {
		printf("First parameter: input file name to encrypt.\n");
		printf("Second parameter: the decrypted file name.\n");
		exit(1);
	} else {
		printf("The first parameter: %s\n",argv[1]); 
	}
	char *ptr_input_fn_argv1 = argv[1];
  //  char *ptr_decrypted_fn = "decrypted.bin";
    char *ptr_encrypted_fn = "encrypted.bin";
	//char *ptr_encrypted_fn = "encrypted.bin";
	char *ptr_decrypted_fn = argv[2];
    set_crypt_keys_one();
    set_crypt_keys_two();
    set_crypt_keys_three();
    set_crypt_keys_four();
    set_crypt_keys_caesar_one(g_ptr_main_struct_caesar_one);
    set_crypt_keys_bitwise_one(g_ptr_main_struct_bitwise_one);
     set_crypt_keys_caesar_two(g_ptr_main_struct_caesar_one);
    set_crypt_keys_bitwise_two(g_ptr_main_struct_bitwise_one);
      set_crypt_keys_caesar_three(g_ptr_main_struct_caesar_one);
    set_crypt_keys_bitwise_three(g_ptr_main_struct_bitwise_one);
       set_crypt_keys_caesar_four(g_ptr_main_struct_caesar_one);
    set_crypt_keys_bitwise_four(g_ptr_main_struct_bitwise_one);
 
    block_copy_encrypt(ptr_input_fn_argv1,ptr_encrypted_fn);
    block_copy_decrypt(ptr_encrypted_fn,ptr_decrypted_fn);
	return(EXIT_SUCCESS);

}
